/*
 * helper.c
 *
 * Created: 2015/09/29 15:37:52
 *  Author: NTAKA
 */ 
#include "std.h"

#include <string.h>
#include <stdlib.h>

#include "helper.h"

//-----------------------------------------------------------
// l116iWL֕̕ϊA
// w̃obt@ dest ̔Cӂ̈ʒu s ֖ߍ
//
// val	  : 0 ` F ̒l
// dest	  : ꂽ󂯎obt@
// s      : ߍ݈ʒuCfbNX
//-----------------------------------------------------------
void replace_val2str_1(uint8_t val, char* dest, uint8_t s)
{
	char buf[32];
	
	itoa(val, buf, 16);
	
	dest[s++] = buf[0];
}

//-----------------------------------------------------------
// l216iWL֕̕ϊA
// w̃obt@ dest ̔Cӂ̈ʒu s ֖ߍ
//
// val	  : 0 ` FF ̒l
// dest	  : ꂽ󂯎obt@
// s      : ߍ݈ʒuCfbNX
//-----------------------------------------------------------
void replace_val2str_2(uint8_t val, char* dest, uint8_t s)
{
	char buf[32];
	
	itoa(val, buf, 16);
	
	if(buf[1] == '\0')
	{
		dest[s++] = '0';
		dest[s++] = buf[0];
	}
	else
	{
		dest[s++] = buf[0];
		dest[s++] = buf[1];
	}
}

//-----------------------------------------------------------
// l416iWL֕̕ϊA
// w̃obt@ dest ̔Cӂ̈ʒu s ֖ߍ
//
// val	  : 0 ` FFFF ̒l
// dest	  : ꂽ󂯎obt@
// s      : ߍ݈ʒuCfbNX
//-----------------------------------------------------------
void replace_val2str_4(uint16_t val, char* dest, uint8_t s)
{
	char buf[32];
	
	itoa(val, buf, 16);
	
	if(buf[1] == '\0')
	{
		dest[s++] = '0';
		dest[s++] = '0';
		dest[s++] = '0';
		dest[s++] = buf[0];
	}
	else if(buf[2] == '\0')
	{
		dest[s++] = '0';
		dest[s++] = '0';
		dest[s++] = buf[0];
		dest[s++] = buf[1];
	}
	else if(buf[3] == '\0')
	{
		dest[s++] = '0';
		dest[s++] = buf[0];
		dest[s++] = buf[1];
		dest[s++] = buf[2];
	}
	else
	{
		dest[s++] = buf[0];
		dest[s++] = buf[1];
		dest[s++] = buf[2];
		dest[s++] = buf[3];
	}
}

//-----------------------------------------------------------
// 񂩂16iŋLqꂽ1̐l擾
//
// *val   : ϊꂽl󂯎ϐւ̃|C^
// str    : M
// s      : li[Ă镶̐擪CfbNX
//
// ߂l : 1 , 0 s
//-----------------------------------------------------------
uint8_t str2val_1(uint8_t *val, const char* str, uint8_t s)
{
	char buf[32];
	char *endp = 0;
	
	buf[0] = str[s];
	buf[1] = '\0';
	
	*val = (uint8_t)strtol(buf, &endp, 16);
	
	if(*endp != '\0')
	return 0;
	
	return 1;
}

//-----------------------------------------------------------
//  񂩂16iŋLqꂽ2̐l擾
//
// *val   : ϊꂽl󂯎ϐւ̃|C^
// str    : M
// s      : li[Ă镶̐擪CfbNX
//
// ߂l : 1 , 0 s
//-----------------------------------------------------------
uint8_t str2val_2(uint8_t *val, const char* str, uint8_t s)
{
	char buf[32];
	char *endp = 0;
	
	buf[0] = str[s++];
	buf[1] = str[s];
	buf[2] = '\0';
	
	*val = (uint8_t)strtol(buf, &endp, 16);
	
	if(*endp != '\0')
		return 0;
	
	return 1;
}

//-----------------------------------------------------------
//  񂩂16iŋLqꂽ4̐l擾
//
// *val   : ϊꂽl󂯎ϐւ̃|C^
// str    : M
// s      : li[Ă镶̐擪CfbNX
//
// ߂l : 1 , 0 s
//-----------------------------------------------------------
uint8_t str2val_4(uint16_t *val, const char* str, uint8_t s)
{
	char buf[32];
	char *endp = 0;
	
	buf[0] = str[s++];
	buf[1] = str[s++];
	buf[2] = str[s++];
	buf[3] = str[s];
	buf[4] = '\0';
	
	*val = (uint16_t)strtol(buf, &endp, 16);
	
	if(*endp != '\0')
	return 0;
	
	return 1;
}
