/*
 * rgb.h
 *
 * Created: 2015/09/29 15:42:54
 *  Author: NTAKA
 */ 


#ifndef RGB_H_
#define RGB_H_


#define COMM_PWM_SET	'S'
#define COMM_PWM_GET	'G'

#define COMM_PWM_R		'R'
#define COMM_PWM_G		'G'
#define COMM_PWM_B		'B'

#define LEDTYPE_R	0
#define LEDTYPE_G	1
#define LEDTYPE_B	2


// PWM l\
typedef struct tag_PWMSETTING
{
	uint8_t R;	// R
	uint8_t G;	// B
	uint8_t B;	// B
} PWMSETTING;


uint8_t proc_Gx(uint8_t led_type, const PWMSETTING *pwm, char *dst);
uint8_t proc_Sx(uint8_t led_type, const char *str, PWMSETTING *pwm, char *dst);

void proc_GD(const PWMSETTING *pwm, char *dst);
uint8_t proc_SD(const char *str, PWMSETTING *pwm, char *dst);


uint8_t str2pwmmode(const char *str, uint8_t *mode);
uint8_t str2pwmsw(const char *str, uint8_t *sw);


#endif /* RGB_H_ */